/**
 * PinHole.java
 *
 * @author Akio Miwa
 * @version 	@(#)PinHole.java	0.5, 10 Apl 2001
 */
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Choice;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;  // 1998/01/30 JDK1.1Event@\荞ނ߂ɒǉ
import java.awt.event.WindowEvent;    // 1998/01/30 JDK1.1Event@\荞ނ߂ɒǉ
import java.awt.image.MemoryImageSource;  // icon̑ɕKv
import java.awt.image.PixelGrabber;       // icon̑ɕKv
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.lang.Math;
import java.lang.Object;
import java.lang.System;    // f[^ǂݍ݂v邽߂Ɏgp
import java.lang.Thread;

/////////////////////////
//PinHoleNX
public class PinHole extends Panel implements Runnable {

//-----------------------------------------------------------
// sAvbgX^hA𔻕ʂ邽߂̃tO
static boolean StandAloneStatus;

/* fobOp̏RpCtO
final static boolean Debug = true;   // fobO
 */
final static boolean Debug = false;  // fobOς

   String[] Diameter = { "0.1", "0.2", "0.3", "0.4", "0.5",
                         "0.6", "0.7", "0.8", "0.9", "1.0"
                       };

   String[] Fnum = { " 1.0", " 1.2", " 1.4", " 1.8",
                     " 2.0", " 2.5", " 2.8", " 3.5",
                     " 4.0", " 4.5", " 5.6", " 6.7",
                     " 8.0", " 9.5", "11.0", "13.0",
                     "16.0", "19.0", "22.0", "27.0",
                     "32.0"
                    };
   String[][] ShutterSpeed = {
        { "30    ", "30.0000000" },
        { "20    ", "20.0000000" },
        { "15    ", "15.0000000" },
        { "10    ", "10.0000000" },
        { " 8    ", " 8.0000000" },
        { " 6    ", " 6.0000000" },
        { " 4    ", " 4.0000000" },
        { " 3    ", " 3.0000000" },
        { " 2    ", " 2.0000000" },
        { " 1.5  ", " 1.5000000" },
        { " 1    ", " 1.0000000" },
        { " 0.7  ", " 0.7000000" },
        { "1/   2", " 0.5000000" },
        { "1/   3", " 0.3333333" },
        { "1/   4", " 0.2500000" },
        { "1/   6", " 0.1666667" },
        { "1/   8", " 0.1250000" },
        { "1/  10", " 0.1000000" },
        { "1/  15", " 0.0666667" },
        { "1/  20", " 0.0500000" },
        { "1/  30", " 0.0333333" },
        { "1/  45", " 0.0222222" },
        { "1/  60", " 0.0166667" },
        { "1/  90", " 0.0111111" },
        { "1/ 125", " 0.0080000" },
        { "1/ 180", " 0.0055556" },
        { "1/ 250", " 0.0040000" },
        { "1/ 350", " 0.0028571" },
        { "1/ 500", " 0.0020000" },
        { "1/ 750", " 0.0013333" },
        { "1/1000", " 0.0010000" },
        { "1/2000", " 0.0005000" }
     };

// Constants
   Thread     killme    = null;
   boolean    runStatus = false;   // stO
   long       ExposureTime = 0;

   TextField  tfFocalLength;
   Choice     choiceDiameter;
   TextField  tfPinholeFnum;

   Panel       pExposureTime;
   TextField  tfExposureTime;

   TextField  tfExposureTimeInv;
   Choice     choiceExposureMeterFnum;

   Panel       pShutterSpeed;
   TextField  tfShutterSpeed;

   Choice     choiceShutterSpeedInv;

   Panel        MainPanel;

   Panel      MatrixPanel1;
   Panel      MatrixPanel2;

   Button     CalcButton;
   Button     StartStopButton;
   Button     ExitButton;

   Panel      ButtonPanel;

   String lblFocalLength;       // œ_(mm)
   String lblDiameter;          // jEa(mm)
   String lblPinholeFnum;       // jE@@f/l
   String lblExposureTime;      // jEIo(sec)
   String lblExposureMeterFnum; // Iov@f/l
   String lblShutterSpeed;      // Vb^[x(sec)

    /**
     * PinHoleN\bh
     */
   public static void main(String argv[]) {
      /** PinHole쐬A\ */
      Frame f = new Frame("jEʐ^@pIoԌvZ@@덆");
      f.add(new PinHole(true), "Center");
      f.addWindowListener(new MyWinListener());
      f.pack();

      // iconC[W̓ǂݍ݂Ƃ̃Zbg
      // VACYꂽACR̃sNZC[W
      // ǂݍݗpicot@ĆA32x32TCYgift@C
      // \߁Agif2ico.java ŕϊďĂƁB
      int w = 32;
      int h = 32;
      int[] pixels = new int[h * w];
      String iconfile = "icon/pinhole.ico";
   // String iconfile = "pinhole.ico";
      try {
         InputStream       is = FixedPoint.class.getResourceAsStream(iconfile);
      // InputStream       is = f.getClass().getResourceAsStream(iconfile);
      // FileInputStream   is = new FileInputStream(iconfile);
         ObjectInputStream si = new ObjectInputStream(is);
         pixels = (int[])si.readObject();
      } catch (Exception e) {
         System.out.println(iconfile+ " read error :" + e);
      }
      // intz񂩂Aimage𕜌B
      PixelImages pi = new PixelImages(w, h, pixels);
      // Icon\B
      if (null != pi) f.setIconImage(pi.getImage());

      /** EBhE̕\ʒuAAݒ肷 */
      Dimension mySize = f.getSize();
      Dimension screenSize   = Toolkit.getDefaultToolkit().getScreenSize();
      f.setLocation((screenSize.width  / 2) - (mySize.width  / 2), 
                    (screenSize.height / 2) - (mySize.height / 2));
      f.setVisible(true); // this.show(); ---jdk102
   }
   /**
    * PinHoleRo[^̃RXgN^
    */
// PinHole(String title, int width, int height, boolean Status) {
// PinHole(String title, boolean Status) {
   PinHole(boolean Status) {
      // sAvbgX^hA𔻕ʂ邽߂̃tOZbg
      StandAloneStatus = Status;
      setLayout(new BorderLayout());
//    MatrixPanel  = new Panel(new GridLayout(3, 5));
//    MatrixPanel  = new Panel(new GridLayout(5, 3));
//      MainPanel  = new Panel(new GridLayout(1, 2));
//      MainPanel  = new Panel();
        MainPanel  = new Panel(new BorderLayout());
      MatrixPanel1 = new Panel(new GridLayout(8, 1));
      MatrixPanel2 = new Panel(new GridLayout(8, 1));

      lblFocalLength       = "œ_(mm)";
      lblDiameter          = "jEa(mm)";
      lblPinholeFnum       = "jE@@f/l";
      lblExposureTime      = "jEIo";
      lblExposureMeterFnum = "Iov@f/l";
      lblShutterSpeed      = "Vb^[x";

      tfFocalLength       = new TextField(" 50.0", 10);
      choiceDiameter      = new Choice();
      for (int i = 0; i < Diameter.length; i++) {
         choiceDiameter.add(Diameter[i]);
      }
      choiceDiameter.select(1);

      tfPinholeFnum       = new TextField(" 250.0000", 10);

   // pExposureTime       = new Panel(new FlowLayout());
   // pExposureTime       = new Panel(new GridLayout(1, 2));
      pExposureTime       = new Panel(new BorderLayout());

      tfExposureTime      = new TextField("   7.8125", 10);
      pExposureTime.add(tfExposureTime  , BorderLayout.CENTER);
      pExposureTime.add(new Label("sec"), BorderLayout.EAST);

      tfExposureTimeInv   = new TextField("1/ 0.1280", 10);
      choiceExposureMeterFnum = new Choice();
      for (int i = 0; i < Fnum.length; i++) {
         choiceExposureMeterFnum.add(Fnum[i]);
      }
      choiceExposureMeterFnum.select(12);

   // pShutterSpeed       = new Panel(new FlowLayout());
   // pShutterSpeed       = new Panel(new GridLayout(1, 2));
      pShutterSpeed       = new Panel(new BorderLayout());

      tfShutterSpeed      = new TextField("   0.0080", 10);
      pShutterSpeed.add(tfShutterSpeed  , BorderLayout.CENTER);
      pShutterSpeed.add(new Label("sec"), BorderLayout.EAST);

      choiceShutterSpeedInv   = new Choice();
      for (int i = 0; i < ShutterSpeed.length; i++) {
         choiceShutterSpeedInv.add(ShutterSpeed[i][0]);
      }
      choiceShutterSpeedInv.select(24);


      MatrixPanel1.add(new Label(lblFocalLength));       // FocalLength
      MatrixPanel2.add(tfFocalLength);


      MatrixPanel1.add(new Label(lblDiameter));          // Diameter
      MatrixPanel2.add(choiceDiameter   );


      MatrixPanel1.add(new Label(lblPinholeFnum));       // Fnumber
      MatrixPanel2.add(tfPinholeFnum); // ɁCjEaZol͂B

      MatrixPanel1.add(new Label(lblExposureMeterFnum)); // Iov@f/l
      MatrixPanel2.add(choiceExposureMeterFnum);

      MatrixPanel1.add(new Label(lblShutterSpeed     )); // Vb^[x(sec)
      MatrixPanel2.add(choiceShutterSpeedInv  );

      MatrixPanel1.add(new Label(""));                   // Dummy
      MatrixPanel2.add(pShutterSpeed     );

      MatrixPanel1.add(new Label(lblExposureTime     )); // jEIo(sec)
      MatrixPanel2.add(tfExposureTimeInv  );

      MatrixPanel1.add(new Label(""));                   // Dummy
      MatrixPanel2.add(pExposureTime     );

      MainPanel.add(MatrixPanel1, BorderLayout.WEST);
      MainPanel.add(MatrixPanel2, BorderLayout.CENTER);

      ButtonPanel = new Panel(new GridLayout(1, 3));
   // ButtonPanel = new Panel(new FlowLayout());
      CalcButton = new Button("Calc");
      CalcButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            CalcButtonActionPerformed(evt);
         }
      });

      StartStopButton = new Button("Start");
      StartStopButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            StartStopButtonActionPerformed(evt);
         }
      });

      ExitButton      = new Button("Exit");
      ExitButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            ExitButtonActionPerformed(evt);
         }
      });

      if (true != StandAloneStatus) {
         // Avbg̏ꍇ͖ɂB
         ExitButton.setEnabled(false);
      // System.out.println(StandAloneStatus);
      }

      ButtonPanel.add(CalcButton);
      ButtonPanel.add(StartStopButton);
      ButtonPanel.add(ExitButton);

      add(MainPanel,   "Center");
      add(ButtonPanel, "South");

//    this.setSize(mySize);
//    this.pack();
//
//    this.setLocation(screenSize.width  / 2 - mySize.width  / 2, 
//                     screenSize.height / 2 - mySize.height / 2);
      this.setVisible(true); // this.show(); ---jdk102
      CalcButton.requestFocus();   // ButtonɃtH[JX^ĂB
   }  // RXgN^Gh

   // ^ꂽmsecPʂŎԑ҂B
   public void wait(int t) {
      try {
         Thread.sleep(t);  // t ~bԂ̒~
      } catch (InterruptedException e){}
   }

   public void run() {
      while (killme != null) {
         ExposureTime--;
         wait(100);
         if (ExposureTime < 0) {
            break;
         }
         tfExposureTime.setText((ExposureTime / 10) + "." + (ExposureTime % 10));
      }
      Toolkit.getDefaultToolkit().beep(); wait(1000);// wait 0.75sec
      Toolkit.getDefaultToolkit().beep(); wait(1000);// wait 0.75sec
      Toolkit.getDefaultToolkit().beep(); wait(1000);// wait 0.75sec
      StartStopButton.setLabel("Start");
      killme = null;
      runStatus = false;         // stO
   }

    private void CalcButtonActionPerformed(java.awt.event.ActionEvent evt) {
         int index;
         // kvmł́A_Z͂łȂH
         // ׂlonggŒ菬_ZőpB
         FixedPoint fl = FixedPoint.Str2FixedPoint(tfFocalLength.getText().trim());

         index = choiceDiameter.getSelectedIndex();
         FixedPoint d  = FixedPoint.Str2FixedPoint(choiceDiameter.getItem(index).trim());
         FixedPoint f2 = FixedPoint.div(fl, d);
         tfPinholeFnum.setText("  " + f2.getDouble(6));

         index = choiceExposureMeterFnum.getSelectedIndex();
         FixedPoint f1 = FixedPoint.Str2FixedPoint(choiceExposureMeterFnum.getItem(index).trim());
         FixedPoint OneSec = FixedPoint.Str2FixedPoint("1.0");
         
         index = choiceShutterSpeedInv.getSelectedIndex();
         FixedPoint tt = FixedPoint.Str2FixedPoint(ShutterSpeed[index][1].trim());
         tfShutterSpeed.setText("  " + tt.getDouble(6));
         FixedPoint a  = FixedPoint.mult(f2, f2);
         FixedPoint b  = FixedPoint.mult(f1, f1);
         FixedPoint mm = FixedPoint.div(a, b);
         FixedPoint pt1 = FixedPoint.mult(tt, mm);
         tfExposureTime.setText("  " + pt1.getDouble(6));
         FixedPoint pt2 = FixedPoint.div(OneSec, pt1);
         tfExposureTimeInv.setText("1/ " + pt2.getDouble(6));

         System.out.println("  " + pt1.getDouble(6) + "sec");
         System.out.println("1/ " + pt2.getDouble(6));

         StartStopButton.requestFocus();   // ButtonɃtH[JX^ĂB
    }

    private void StartStopButtonActionPerformed(java.awt.event.ActionEvent evt) {
       if (evt.getActionCommand().equals("Start")) {
if (Debug) System.out.println("Start");
          StartStopButton.setLabel("Stop");
          runStatus = true;         // stO
          FixedPoint t  = FixedPoint.Str2FixedPoint(tfExposureTime.getText().trim());
          // 1/10b̕\\ɂ邽ߒl10{ɂĂB
          FixedPoint et = new FixedPoint(t.num * 10, t.point);
          ExposureTime = et.getLong();
          if (killme == null) {
              killme = new Thread(this);
              killme.start();
              Toolkit.getDefaultToolkit().beep();
          }
       } else if (evt.getActionCommand().equals("Stop")) {
          StartStopButton.setLabel("Start");
if (Debug) System.out.println("Stop");
          killme = null;
          runStatus = false;         // stO
          CalcButton.requestFocus();   // ButtonɃtH[JX^ĂB
       }
    }

    private void ExitButtonActionPerformed(java.awt.event.ActionEvent evt) {
        killme = null;
        runStatus = false;         // stO
        System.exit(0);
    }


   public long Str2Long(String str) {
      long l = 0;
      for (int i = 0; i < str.length(); i++) {
         if (true == Character.isDigit(str.charAt(i))) {
            l *= 10;
            l += Character.digit(str.charAt(i), 10);
         }
      }
      return l;
   }

   // EBhE[]{^Ƃ̏
   protected static final class MyWinListener extends WindowAdapter {
      public void windowClosing(WindowEvent e) {
         if (true == StandAloneStatus) {
            // X^hAƂĎs̏ꍇ̂݁AIB
            System.exit(0);
         } else {
            // Avbg̏ꍇ͖ɂAxȂ炷B
            Toolkit.getDefaultToolkit().beep();
         }
      }
   }
}


// int zɓWJꂽC[WImageɕϊ邽߂class
class PixelImages extends Component {
   int w = 32;
   int h = 32;
   int[] pixels;

   PixelImages(int w, int h, int[] pixels){
      this.w = w;
      this.h = h;
      this.pixels = new int[h * w];
      this.pixels = pixels;
   }

   Image getImage() {
      return createImage(new MemoryImageSource(w, h, pixels, 0, w));
   }
}
