import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.io.*;

public class PinHoleLauncher extends Applet implements ActionListener {

   Button    openButton;
   Button   closeButton;
   Frame    pinholeFrame;
   Label    versionLabel;
   Label    messageLabel;

   public void init() {
      String vers = System.getProperty("java.version");
      versionLabel = new Label("java.version " + vers, Label.CENTER);
      String message = "";
      if (vers.compareTo("1.1") < 0) {
         message = "!!!WARNING: Swing must be run with a " +
                           "1.1 or higher version VM!!!";
      } else {
         message = "Please click [Open] button !";
      }
      messageLabel = new Label(message, Label.CENTER);

       openButton = new Button("Open");
      closeButton = new Button("Close");
       openButton.addActionListener(this);
      closeButton.addActionListener(this);

      Panel buttonPanel = new Panel(new GridLayout(1, 2));
      buttonPanel.add( openButton);
      buttonPanel.add(closeButton);

      setLayout(new BorderLayout());

      add("North", versionLabel);
      add("Center", buttonPanel);
      add("South", messageLabel);

       openButton.requestFocus();   // ButtonɃtH[JX^ĂȂƍŏ̃L[͂ɔȂB
   }

   public void actionPerformed(ActionEvent event) { 
      String label = ((Button)event.getSource()).getLabel(); 
      if (label.equals("Open")) {
         if (pinholeFrame == null) {   // t[̐
            pinholeFrame = new Frame("jEʐ^@pIoԌvZ@@덆");
            pinholeFrame.add(new PinHole(false), "Center");
            pinholeFrame.addWindowListener(new MyWinListener());
            pinholeFrame.pack();

            // iconC[W̓ǂݍ݂Ƃ̃Zbg
            // VACYꂽACR̃sNZC[W
            // ǂݍݗpicot@ĆA32x32TCYgift@C
            // \߁Agif2ico.java ŕϊďĂƁB
            int w = 32;
            int h = 32;
            int[] pixels = new int[h * w];
            String iconfile = "icon/pinhole.ico";
         // String iconfile = "pinhole.ico";
            try {
               InputStream  is = FixedPoint.class.getResourceAsStream(iconfile);
               ObjectInputStream si = new ObjectInputStream(is);
               pixels = (int[])si.readObject();
            } catch (Exception e) {
               System.out.println(iconfile+ " read error :" + e);
            }
            // intz񂩂Aimage𕜌B
            PixelImages pi = new PixelImages(w, h, pixels);
            // Icon\B
            if (null != pi) pinholeFrame.setIconImage(pi.getImage());

            /** EBhE̕\ʒuAAݒ肷 */
            Dimension mySize = pinholeFrame.getSize();
            Dimension screenSize   = Toolkit.getDefaultToolkit().getScreenSize();
            pinholeFrame.setLocation((screenSize.width  / 2) - (mySize.width  / 2), 
                                     (screenSize.height / 2) - (mySize.height / 2));
            pinholeFrame.setVisible(true);       // t[\B
         }
      } else if (label.equals("Close")) {
         if (pinholeFrame != null) {
            pinholeFrame.dispose(); // AvbgĂяot[
            pinholeFrame = null;
         }
      }
   }

   public void stop() {
      // AvbgIt[B
      pinholeFrame.setVisible(false);   // hide();
      pinholeFrame.dispose();
   }

   public void destroy() {
      if (pinholeFrame != null) {
         pinholeFrame.dispose(); // AvbgĂяot[
         pinholeFrame = null;
      }
   }

   // EBhE[]{^Ƃ̏
   protected static final class MyWinListener extends WindowAdapter {
       public void windowClosing(WindowEvent e) {
         if (true == PinHole.StandAloneStatus) {
            // X^hAƂĎs̏ꍇ̂݁AIB
            System.exit(0);
         } else {
            // Avbg̏ꍇ͖ɂAxȂ炷B
            Toolkit.getDefaultToolkit().beep();
         }
      }
   }
}